diff -Nrc2 gmp-main.8b074a2e0134/config.guess gmp-main/config.guess
*** gmp-main.8b074a2e0134/config.guess	Thu Feb 27 16:57:35 2014
--- gmp-main/config.guess	Thu Feb 27 16:57:35 2014
***************
*** 815,818 ****
--- 815,828 ----
            else if (model == 0x56) cpu_64bit = 1, modelstr = "coreibwl"; /* Broadwell microserver */
            else cpu_64bit = 1, modelstr = "corei"; /* default */
+ 
+ 	  if (strcmp (modelstr, "coreihwl") == 0)
+ 	    {
+ 	      /* Some Haswells lack BMI2.  Let them appear as Sandybridges for
+ 		 now.  */
+ 	      CPUID (dummy_string, 7);
+ 	      if ((dummy_string[0 + 8 / 8] & (1 << (8 % 8))) == 0)
+ 		modelstr = "coreisbr";
+ 	    }
+ 
  	  break;
  	case 15:
***************
*** 901,904 ****
--- 911,917 ----
  EOF
  
+ # The rcx/ecx zeroing here and in the variant below is needed for the BMI2
+ # check.
+ 
    cat <<EOF >${dummy}0.s
  	.globl cpuid
***************
*** 909,912 ****
--- 922,926 ----
  	mov	%rdx, %r8
  	mov	%ecx, %eax
+ 	xor	%ecx, %ecx
  	.byte	0x0f
  	.byte	0xa2
***************
*** 940,943 ****
--- 954,958 ----
  	pushl %ebx
  	movl 24(%esp),%eax
+ 	xor	%ecx, %ecx
  	.byte 0x0f
  	.byte 0xa2
diff -Nrc2 gmp-main.8b074a2e0134/mpn/x86_64/fat/fat.c gmp-main/mpn/x86_64/fat/fat.c
*** gmp-main.8b074a2e0134/mpn/x86_64/fat/fat.c	Thu Feb 27 16:57:35 2014
--- gmp-main/mpn/x86_64/fat/fat.c	Thu Feb 27 16:57:35 2014
***************
*** 293,297 ****
  	      CPUVEC_SETUP_coreinhm;
  	      CPUVEC_SETUP_coreisbr;
! 	      CPUVEC_SETUP_coreihwl;
  	      break;
  	    }
--- 293,301 ----
  	      CPUVEC_SETUP_coreinhm;
  	      CPUVEC_SETUP_coreisbr;
! 	      /* Some Haswells lack BMI2.  Let them appear as Sandybridges for
! 		 now.  */
! 	      __gmpn_cpuid (dummy_string, 7);
! 	      if ((dummy_string[0 + 8 / 8] & (1 << (8 % 8))) != 0)
! 		CPUVEC_SETUP_coreihwl;
  	      break;
  	    }
diff -Nrc2 gmp-main.8b074a2e0134/mpn/x86_64/fat/fat_entry.asm gmp-main/mpn/x86_64/fat/fat_entry.asm
*** gmp-main.8b074a2e0134/mpn/x86_64/fat/fat_entry.asm	Thu Feb 27 16:57:35 2014
--- gmp-main/mpn/x86_64/fat/fat_entry.asm	Thu Feb 27 16:57:35 2014
***************
*** 184,188 ****
  C
  C This is called only 3 times, so just something simple and compact is fine.
! 
  
  define(`rp',  `%rdi')
--- 184,189 ----
  C
  C This is called only 3 times, so just something simple and compact is fine.
! C
! C The rcx/ecx zeroing here is needed for the BMI2 check.
  
  define(`rp',  `%rdi')
***************
*** 193,196 ****
--- 194,198 ----
  	mov	%rbx, %r8
  	mov	R32(idx), R32(%rax)
+ 	xor	%ecx, %ecx
  	cpuid
  	mov	%ebx, (rp)
